#! /usr/bin/python
# coding: utf-8

name = "OnceUponABot"
chans = ["##tdct-jeux"]
server = "irc.freenode.org"

import irc.bot, irc.strings, threading
class Bot(irc.bot.SingleServerIRCBot):
	def __init__(self):
		irc.bot.SingleServerIRCBot.__init__(self,
			[(server, 6667)], name, name)
		self.games = {}
	
	def on_welcome(self, c, e):
		for chan in chans:
			c.join(chan)
	
	def on_privmsg(self, c, e):
		nick = e.source.nick.decode()
		c.action(nick, u"câline "+nick)
	
	def on_pubmsg(self, c, e):
		if e.arguments[0][0] != "!":
			return
		nick = e.source.nick.decode()
		words = e.arguments[0].split()
		gid = words[0][1:].lower()
		if gid in games.keys():
			if len(self.games) == 0: num = 1
			else: num = max(self.games.keys())+1
			try: gam = games[gid](words[1:])
			except Exception as ex:
				c.privmsg(e.target, nick+u", "+unicode(ex))
				return
			self.games[num] = gam
			c.privmsg(e.target, gid+u" #"+unicode(num)+unicode(gam))
			return
		try: num = int(gid)
		except Exception: return
		if num not in self.games.keys():
			return
		game = self.games[num]
		try: ended = game.usertry(words[1:])
		except Exception as ex:
			c.privmsg(e.target, nick+u", "+unicode(ex))
			return
		if ended: self.games.pop(num)
		c.privmsg(e.target, nick+u", "+unicode(game))

import random
class MasterMind(object):
	def __init__(self, words):
		if len(words) == 0: count,values = 4,6
		else: count,values = int(words[0]),int(words[1])
		if values < 1 or values > 26:
			raise Exception(u"il n'y a que 26 lettres !")
		self.maxletter = unichr(64+values)
		self.solution = ""
		for i in range(count):
			self.solution += unichr(random.randint(65, 64+values))
		self.message = (u" : "+str(len(self.solution))+u" lettres à"
			+ u" trouver entre A et "+self.maxletter+u".")
	
	def usertry(self, words):
		ut = u"".join(words).upper()
		if ut == self.solution:
			self.message = unicode(len(self.solution))
			self.message += u" bien placées, bravo !"
			return True
		if len(ut) != len(self.solution):
			self.message = u"on a dit "+unicode(len(self.solution))
			self.message += u" lettres, pas "+unicode(len(ut))+u" !"
			return False
		goods,nears,usertry,check = 0,0,"",""
		for i in range(len(self.solution)):
			if self.solution[i] != ut[i]:
				check += self.solution[i]
				usertry += ut[i]
			else: goods += 1
		for letter in usertry:
			if letter in check:
				r,s,t = check.partition(letter)
				check = r+t
				nears += 1
		self.message = unicode(goods)+u" bien placées, "
		self.message += unicode(nears)+u" mal placées."
		return False
	
	def __str__(self):
		return self.message
games = {u"mastermind": MasterMind}

import string, unicodedata
class Hangman(object):
	def __init__(self, words):
		f = open("/usr/share/dict/french", "r")
		wlist = f.readlines()
		f.close()
		try:
			l = int(words[0])+1
			wlist = list(filter(lambda w: len(w) == l, wlist))
		except Exception: pass
		if len(wlist) == 0:
			raise Exception(u"pas de mot trouvé…")
		self.word = random.choice(wlist)[:-1].decode("utf-8")
		self.word = u"".join(x for x in unicodedata.normalize("NFKD",
			self.word) if x in string.ascii_letters).upper()
		self.message = u" :"+(u" _"*len(self.word))
		self.tries = []
	
	def usertry(self, words):
		check = u"".join(words)
		if len(check) != 1:
			if len(check) == len(self.word):
				check = u"".join(x for x in
					unicodedata.normalize("NFKD", check)
					if x in string.ascii_letters).upper()
				if check == self.word:
					self.message = u"bravo ! C'était bien "
				else: self.message = u"non, ce n'est pas "
				self.message += u" ".join(check)
				return check == self.word
			self.message = u"une lettre à la fois !"
			return False
		check = check.upper()
		if ord(check) not in range(65, 91):
			self.message = u"une lettre entre A et Z !"
			return False
		self.tries.append(check)
		guess,wrongs = u"",set()
		for letter in self.tries:
			if letter not in self.word:
				wrongs.add(letter)
		for letter in self.word:
			if letter in self.tries:
				guess += u" "+letter
			else: guess += u" _"
		if guess == u" "+(u" ".join(self.word)):
			self.message = u"bravo ! C'était bien "+guess+u"."
			return True
		if len(wrongs) >= 12:
			self.message = u"perdu ! C'était "
			self.message += (u" ".join(self.word))+u"."
			return True
		if len(wrongs) == 0:
			self.message = guess
			return False
		wrongs = list(wrongs)
		while len(wrongs) < 11:
			wrongs.append("*")
		self.message = guess+u" ["+(", ".join(wrongs))+u"]"
		return False
	
	def __str__(self):
		return self.message
games[u"pendu"] = Hangman

if __name__ == '__main__':
	Bot().start()
